// @ts-ignore
import {TgHttp} from "@coreHttp";
// @ts-ignore
import apis from "@core/apisPlus";
import {useBizChangePsd, useBizLogin, useBizLogout} from "@webApp/extension/login";

// 登录
export const useLogin = async (params: any) => {
    //调用业务的登录
    let res = await useBizLogin(params)
    if (res && res?.success == true) {
        return res
    } else {
        const request = new TgHttp();
        request.entity = params;
        return request.build(apis["coreSSO.ts"].Login, {noMsg: true}).post();
    }

};

// 退出
export const useLogout = async () => {
    let res = await useBizLogout()
    if (res && res?.success == true) {
        return res
    } else {
        const request = new TgHttp();
        return request.build(apis["coreSSO.ts"].Logout).post();
    }
};

// 修改密码
export const useChangePsd = async (params: any) => {
    let res = await useBizChangePsd(params)
    if (res && res?.success == true) {
        return res
    } else {
        const request = new TgHttp();
        request.entity = params;
        return request.build(apis["coreSSO.ts"].Password).post();
    }
}

// 获取验证码
export const useGetValCode = async (params: any) => {
    const request = new TgHttp();
    request.queryString = params;
    return request.build(apis["coreSSO.ts"].ValCode)
        .setResponseType('arraybuffer')
        .get();

}
