import tgImportCore from './TgImportCore.vue'
import {createApp} from 'vue'
import {
    ElButton,
    ElCard,
    ElCol,
    ElDialog,
    ElDropdown,
    ElDropdownItem,
    ElDropdownMenu,
    ElForm,
    ElFormItem,
    ElIcon,
    ElInput,
    ElOption,
    ElPagination,
    ElProgress,
    ElRow,
    ElSelect,
    ElStep,
    ElSteps,
    ElTable,
    ElTableColumn,
    ElTooltip,
    ElUpload
} from "element-plus";
import TgDialog from "@core/components/base/TgDialog.vue";
import TgButton from "@core/components/base/TgButton.vue";
import TgTableListPlus from "@coreComponents/crudPlus/TgTableListPlus/TgTableListPlus.vue";
import TgDrawer from "@core/components/base/TgDrawer.vue";
import TgInputPlus from "@core/components/base/TgInputPlus.vue";
import TgInput from "@core/components/base/TgInput.vue";

import TgPagination from '@core/components/base/tgPagination/index.vue';
import TableConfigPlus from "@coreComponents/crudPlus/TgTableListPlus/TableConfigPlus.vue";
import draggable from "vuedraggable";
import uploader from 'vue-simple-uploader';
import {DArrowRight, Setting} from "@element-plus/icons-vue";

const TgImportCore = function (options = {}) {
    if (window.tgImportCoreInstance) return
    const mountNode = document.createElement('div')
    mountNode.setAttribute('class', 'tg-import-core')

    const importList = createApp(tgImportCore, options)
    importList.use(uploader)
    importList.component("ElTooltip", ElTooltip);
    importList.component("ElDialog", ElDialog);
    importList.component("ElForm", ElForm);
    importList.component("ElFormItem", ElFormItem);
    importList.component("ElIcon", ElIcon);
    importList.component("ElButton", ElButton);
    importList.component("ElInput", ElInput);
    importList.component("ElRow", ElRow);
    importList.component("ElCol", ElCol);
    importList.component("ElTable", ElTable);
    importList.component("ElTableColumn", ElTableColumn);
    importList.component("ElPagination", ElPagination);
    importList.component("ElUpload", ElUpload);
    importList.component("ElSteps", ElSteps);
    importList.component("ElStep", ElStep);
    importList.component("ElSelect", ElSelect);
    importList.component("ElOption", ElOption);
    importList.component("ElProgress", ElProgress);
    importList.component('ElDropdown', ElDropdown)
    importList.component('ElDropdownMenu', ElDropdownMenu)
    importList.component('ElDropdownItem', ElDropdownItem)
    importList.component("ElCard", ElCard)
    importList.component("TgDialog", TgDialog);
    importList.component("TgButton", TgButton);
    importList.component('TgDrawer', TgDrawer)
    importList.component('TgPagination', TgPagination)
    importList.component('TgInputPlus', TgInputPlus)
    importList.component('TgInput', TgInput)
    importList.component('draggable', draggable)
    importList.component('TgTableListPlus', TgTableListPlus)
    importList.component('TableConfigPlus', TableConfigPlus)

    importList.component('Setting', Setting)
    importList.component('DArrowRight', DArrowRight)

    // importList.component('uploader', uploader.Uploader);
    // importList.component('uploader-btn', uploader.UploaderBtn);
    // importList.component('uploader-drop', uploader.UploaderDrop);
    // importList.component('uploader-file', uploader.UploaderFile);
    // importList.component('uploader-flies', uploader.UploaderFiles);
    // importList.component('uploader-list', uploader.UploaderList);
    // importList.component('uploader-unsupport', uploader.UploaderUnsupport);

    importList.directive('loading', {})
    importList.directive('tg-table', {})

    importList.mount(mountNode)

    document.body.appendChild(mountNode)
    window.tgImportCoreInstance = importList
    if (importList._instance == null) {
        importList._instance = window.tgImportCoreInstance
    }
    return importList._instance
}

export default {
    tgImportCore: TgImportCore,
    async install(app) {
        app.provide('tg-import-core', TgImportCore)
    }
}
