// import { getCurrentInstance } from 'vue'
/*


*/
import {tmn, tm, t} from '@i18nHelper'
const packageRuleItem = (param) => {
    let item = param
    const {message = '',validator =''} = item
    item = Object.assign({},{
        trigger: ['blur','change']
    },param)

    // 长度最大值
    if( item.max && !item.min ) {
        if( !message ) {
            item.message =t('tg.page.components.tgFilter.M00124',[item.max])
        }
    }

    // 长度最小值
    if( !item.max && item.min) {
        if( !message ) {
            item.message = t('tg.page.components.tgFilter.M00125',[item.min])
        }
    }

    // 长度介于 min 和 max
    if( item.max && item.min) {
        if( !message ) {
            item.message =t('tg.page.components.tgFilter.M00126',[item.min,item.max])
        }
    }

    // 数字
    if(item.type) {
        let type = item.type
        if(type === 'number') {
            if(!message) {
                item.message = t('tg.page.components.tgFilter.M00127')
            }
            if(!validator) {
                item.validator = (rule ,value ,callback) =>{
                    // debugger;
                    if( !rule.required && !value ) {
                        callback()
                    }else {
                        // 正数、负数、和小数：
                        const patrn = /^(\-|\+)?\d+(\.\d+)?$/
                        if(!patrn.exec(value)) {
                            callback(new Error(rule.message))
                        }
                    }
                    callback()
                }
            }
        }else if(type === 'email') {
            if(!message) {
                item.message = t('tg.page.msg.M00159')
            }
        }else if(type === 'chart') {

        }
    }

    // 字符串


    return item
}
export default function () {
//     const { proxy } = getCurrentInstance()
    const addRuleEx = (codeList,extend) => {
        let rules = {}
         // 字符串
         if( codeList.constructor === String ) {
             let array = codeList.split(",")
             for (let index in array) {
                 let item = array[index]
                 let rule = rules[item]
                 if (!rule) {
                     rule = []
                 }

                 rule.push({
                     required: true,
//                   message: proxy.$t('tg_filter_require'),
                     message: t('tg.page.tgPage.basePage.NotNull'),
                     trigger: ['blur','change']
                 })
                 rules[item] = rule
             }
         }
        // 扩展 extend
        if(extend && extend.constructor === Object) {
        for(let p in extend ) {
            if(!rules[p]) {
                rules[p] = []
            }
            let item = extend[p]
            if( item.constructor ===Array ) {
               for( let q in item ) {
                    let packageRule = packageRuleItem(item[q])
                    rules[p].push(packageRule)
               }
            }else {
                //  rules[p].push(item)
            }
        }}

        return rules
    }
    return {
        addRuleExpression: addRuleEx
    }
}
