// 运维监控
// 处理日期
const optDate = (dateObj, format) => {
  let year = dateObj.getFullYear(),
    month = dateObj.getMonth() + 1,
    date = dateObj.getDate();

  month = month < 10 ? "0" + month : month;
  date = date < 10 ? "0" + date : date;

  return format && format === "month"
    ? `${year}-${month}`
    : `${year}-${month}-${date}`;
};

const getDate = {
  // 昨天
  yesterday() {
    //昨天的时间
    var day1 = new Date();
    day1.setTime(day1.getTime() - 24 * 60 * 60 * 1000);
    return {
      createTimeStart: optDate(day1),
      createTimeEnd: optDate(day1),
    };
  },
  // 今天
  today() {
    return {
      createTimeStart: optDate(new Date()),
      createTimeEnd: optDate(new Date()),
    };
  },
  // 最近 7 天
  last7() {
    //昨天的时间
    var day1 = new Date();
    day1.setTime(day1.getTime() - 7 * 24 * 60 * 60 * 1000);

    return {
      createTimeStart: optDate(day1),
      createTimeEnd: optDate(new Date()),
    };
  },

  // 本月
  currentMounth() {
    return {
      createTimeStart: optDate(new Date(), "month") + "-01",
      createTimeEnd: optDate(new Date()),
    };
  },
};

const DateObj = {
  yesterday:{
    name: t('tg.page.common.yesterday')
  },
  today:{
    name: t('tg.page.common.today')
  },
  last7:{
    name: t('tg.page.common.lastWeek')
  },
  currentMounth:{
    name: t('tg.page.common.thisMonth')
  },
}
export { getDate, DateObj };
