/**
 * 注册i18n国际化
 */
import { createI18n } from 'vue-i18n' //引入vue-i18n组件
import languagePack from './language'
import localStorage from '@core/utils/TgLocalStorage'
import {SettingCore} from "@core/setting";

// 国际化常量 constant
const LANGUAGE_KEY = "language|" + SettingCore.InternationType
const FIRST_LEVEL_CACHE = SettingCore.FIRST_LEVEL_CACHE

export default function (app) {
    const langStr = localStorage.get('eci@CacheLang') || 'ch'
    const language = ((navigator.language ? navigator.language : navigator.userLanguage) || "ch").toLowerCase()
    const userInfo = localStorage.get('userinfo')
    var message = {
        ...languagePack
    }

    const i18n = createI18n({
        fallbackLocale: 'ch',
        globalInjection: true,
        legacy: false, // you must specify 'legacy: false' option
        locale: langStr ? langStr : language.split("-")[0],
        messages: message,
        silentTranslationWarn: true // 关闭vue-i18n warnning提示
    })
    app.use(i18n)
    return i18n
}
