import type { IDataTrans } from "./tgHttp";
import { TgHttp } from "../utils/TgRequest/axios/TgHttpBase";
import { ResultEnum } from "../enums/httpEnum";
type Recordable<T = any> = Record<string, T>;
export interface IExecuteInfo {
  lastLogDate: string;
  requestTime: string;
  responseTime: string;
  cost: number;
  apiPath: string;
  responseId: string;
  listLog: IEciExecuteLog[];
}
export interface IEciExecuteLog {
  name?: string;
  memo?: string;
  logTime?: string;
  cost: number;
  costTotal?: number;
  success?: boolean;
}
export interface IEciRuntime {
  selectVersion: string;
}
export interface ILogCatchAccessInfo {
  accessId?: string;
  beginDate?: string;
  apiPath?: string;
  endDate?: string;
  cost?: number;
  listLogInfo?: ILogInfo[];
}
export interface ILogInfo {
  //   @JsonIgnore
  // private String accessId;
  // private String name;
  // private String message;
  // private String sql;
  // private boolean error;
  accessId: string;
  name: string;
  message: string;
  sql: string;
  error: string;
  logDate: string;
}
export interface IPage {
  index: number;
  size: number;
  recordCount?: number;
  pageCount?: number;
  maxExpCount?: number;
  sortExpression?: string;
  isExport?: boolean;
}

export interface IUIExecuteInfo {
  request?: TgHttp;
  logCatchInfo?: ILogCatchAccessInfo;
  executeInfo?: IEciExecuteLog;
  api?: string;
  requestData?: string;
  responseData?: string;
  success: boolean;
  successColor: string;
  cost: number;
  costColor: string;
}

export class BaseDto {}
