import type {EciResponse} from "./ecitrans";

/**
 * 文件传输接口
 */
export interface IFileTrans {
    upload: Function;
    addFile: (name: string, content: File | Blob, fileName: string) => IFileTrans;
}

/**
 * 数据传输接口
 */
export interface IDataTrans {
    post: () => Promise<EciResponse | null | undefined>;
    get: () => Promise<EciResponse | null | undefined>;
    delete: () => Promise<EciResponse | null | undefined>;
    put: () => Promise<EciResponse | null | undefined>;
    download: (title: string) => Promise<EciResponse | null | undefined>;
    export: (title: string) => Promise<EciResponse | null | undefined>;
    addFile: (name: string, content: File | Blob, fileName: string) => IFileTrans;
    then: Function;
    catch: Function;
}
