/**
 * @description 全局基础工具类 - element-plus 多次调用只弹一次
 * @author Jerome.luo
 * @date 2022/06/07
 * @export
 * @return { * }
 */

import ElementPlus, { ElMessage }  from 'element-plus'
import 'element-plus/dist/index.css'

// 定义唯一标识
const tgCustomMessage = Symbol("tgCustomMessage");
class CusMessage {
    // single默认值true，弹出一次
    success (options, single = true) {
        this[tgCustomMessage]("success", options, single)
    }
    warning (options, single = true) {
        this[tgCustomMessage]("warning", options, single)
    }
    info (options, single = true) {
        this[tgCustomMessage]("info", options, single)
    }
    error (options, single = true) {
        this[tgCustomMessage]("error", options, single)
    }
    // 类型调用  如：success => [tgCustomMessage]('success', options, true)
    [tgCustomMessage] (type, options, single) {
        // 判断每种type的Message是否只支持调用一次
        if (single) {
            if (document.getElementsByClassName("el-message").length === 0) {
                ElMessage[type](options)
            }
        } else {
            ElMessage[type](options)
        }
    }
}

export const elementUI = ElementPlus
export const TgMessage = new CusMessage()
