import CryptoJS from 'crypto-js'; //引用AES源码js

//const key = CryptoJS.enc.Utf8.parse("1234123412ABCDEF");  //十六位十六进制数作为密钥
const iv = CryptoJS.enc.Utf8.parse('ABCDEF1234123412'); //十六位十六进制数作为密钥偏移量

//解密方法
function DecryptAes(word, key) {
    try {
        //let data = CryptoJS.enc.Utf8.parse(word);
        key = CryptoJS.enc.Utf8.parse(key);
        //let srcs = CryptoJS.enc.Base64.stringify(data);
        let decrypt = CryptoJS.AES.decrypt(word, key, {
            iv,
            mode: CryptoJS.mode.CBC,
            padding: CryptoJS.pad.Pkcs7
        });
        let decryptedStr = decrypt.toString(CryptoJS.enc.Utf8);
        return decryptedStr.toString();
    } catch (err) {
        console.log(err)
        console.log(err.msg);
    }
}

//加密方法
function EncryptAes(word, key) {
    let srcs = CryptoJS.enc.Utf8.parse(word);
    key = CryptoJS.enc.Utf8.parse(key);
    let encrypted = CryptoJS.AES.encrypt(srcs, key, {
        iv,
        mode: CryptoJS.mode.CBC,
        padding: CryptoJS.pad.Pkcs7
    });
    return encrypted.toString(); //.ciphertext
}

//SHA256加密
function CryptoSHA256(word) {
    return CryptoJS.SHA256(word).toString();
}


//生成AES秘钥
function GenerateKey() {
    var result = '';
    for (var i = 0; i < 16; i++) {
        result += Math.floor(Math.random() * 16).toString(16); //获取0-15并通过toString转16进制
    }
    //默认字母小写，手动转大写
    return result.toUpperCase(); //toLowerCase()
}
export default {
    DecryptAes,
    EncryptAes,
    CryptoSHA256,
    GenerateKey
}
