import useWujieRouter from '@core/utils/wujie/useWujieRouter';
import { SettingCore } from '@core/setting';

export default function useTgExcel() {
    const { customRouterPush } = useWujieRouter();

    const excelId = SettingCore.tgExcelId ?? '';

    const routeToExcelImport = (params) => {
        const { id = excelId } = params
        customRouterPush({
            path: '/TG_EXCEL/tianGong/importPage',
            appName: 'TG_EXCEL',
            _blank: true,
            query: {
                ...params,
                id,
                showType: 'common',
            }
        });
    };

    return {
        routeToExcelImport
    };
}
