import * as extension from '@/web/extension'

/**
 *  @description: 扩展的登录
 */
const useBizLogin = (params) => {
    if (extension.default?.login?.default.useBizLogin) {
        return new Promise(async (resolve) => {
            let rtn = await extension.default?.login?.default.useBizLogin(params)
            resolve(rtn)
        })
    }

    return new Promise((resolve, reject) => {
        resolve(true)
    })
}


/**
 *  @description: 扩展的登出
 */
const useBizLogout = () => {
    if (extension.default?.login?.default.useBizLogout) {
        return new Promise(async (resolve) => {
            let rtn = await extension.default?.login?.default.useBizLogout()
            resolve(rtn)
        })
    }

    return new Promise((resolve, reject) => {
        resolve(true)
    })
}

/**
 *  @description: 扩展的修改密码
 */
const useBizChangePsd = (params) => {
    if (extension.default?.login?.default.useBizChangePsd) {
        return new Promise(async (resolve) => {
            let rtn = await extension.default?.login?.default.useBizChangePsd(params)
            resolve(rtn)
        })
    }

    return new Promise((resolve, reject) => {
        resolve(true)
    })
}
export {
    useBizLogin,
    useBizLogout,
    useBizChangePsd,
}
