import {tm} from "@i18nHelper";

export const searchFormSchema = [
    {
        label: tm('sysDataHelp.queryKey', '查询类型'),
        field: "queryKey", //字段名称
        span: 8, //控件占位长度
        labelWidth: "100px", //label占用长度
        show: true, //是否显示该控件
        query: "auto", //查询配置
        component: "Input", //控件类型：Input,Select,Choose,DateRange,DateTimeRange
        componentProps: {
            //组件属性对象
            dataType: "", //放大镜，下拉框的数据来源
        },
    },

    {
        label: tm('sysDataHelp.baseComment', '备注'),
        field: "baseComment", //字段名称
        span: 8, //控件占位长度
        labelWidth: "100px", //label占用长度
        show: true, //是否显示该控件
        query: "auto", //查询配置
        component: "Input", //控件类型：Input,Select,Choose,DateRange,DateTimeRange
        componentProps: {
            //组件属性对象
            dataType: "", //放大镜，下拉框的数据来源
        },
    },
    {
        label: tm('sysDataHelp.useCache', '使用缓存'),
        field: "useCache", //字段名称
        span: 8, //控件占位长度
        labelWidth: "100px", //label占用长度
        show: true, //是否显示该控件
        query: "auto", //查询配置
        component: "Select", //控件类型：Input,Select,Choose,DateRange,DateTimeRange
        componentProps: {
            //组件属性对象
            // dataType: "BASE_SETTLEMENT", //放大镜，下拉框的数据来源
            // placeholder: "代码", //背景提示文本,
            // dataFirst: true
            // codeOnly: true
            // dataJoin: true
            // multiple: true,//多选
            addEmpty: true,
            dataCustom: "Y|是,N|否"
        },
    },


];

export const columns = [
    {
        label: tm('sysDataHelp.queryKey', '基础参数key'),
        field: "queryKey",
        show: false,
        width: "100px",
        export: true,
        fixed: true,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysDataHelp.baseComment', '备注'),
        field: "baseComment",
        show: true,
        width: "160px",
        export: true,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysDataHelp.useCache', '使用缓存'),
        field: "useCache",
        show: true,
        width: "160px",
        export: true,
        fixed: true,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysDataHelp.dataChangeCode', '代码字段'),
        field: "dataChangeCode",
        show: true,
        width: "160px",
        export: true,
        fixed: true,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysDataHelp.dataChangeName', '名称字段'),
        field: "dataChangeName",
        show: true,
        width: "160px",
        export: true,
        fixed: true,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysDataHelp.sys', '系统'),
        field: "sys",
        show: true,
        width: "160px",
        export: true,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },

];
