import {tm} from '@i18nHelper'

export const searchFormSchema = [
    {

        label: tm('eciFileInfo.bizNo', '业务单号'),
        field: "bizNo",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciFileInfo.bizType', '业务类型'),
        field: "bizType",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Choose",
        componentProps: {
            dataType: "FILE_BIZ_TYPE",
            placeholder: "",
        },
    },
    {

        label: tm('eciFileInfo.fileName', '文件名'),
        field: "fileName",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciFileInfo.path', '文件路径'),
        field: "path",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciFileInfo.createDate', '创建日期'),
        field: "createDate",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "DateRange",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciFileInfo.saveDb', '是否保存数据库'),
        field: "saveDb",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "Y|是,N|否"

        },
    },
    {

        label: tm('eciFileInfo.status', '状态'),
        field: "status",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "Y|是,N|否"
        },
    },
    {

        label: tm('eciFileInfo.extension', '拓展名'),
        field: "extension",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
];

export const columns = [
    {
        label: tm('eciFileInfo.bizNo', '业务单号'),
        field: "bizNo",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.bizType', '业务类型'),
        field: "bizType",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
   
    {
        label: tm('eciFileInfo.fileName', '文件名'),
        field: "fileName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.fileNameOri', '原文件名'),
        field: "fileNameOri",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.path', '文件路径'),
        field: "path",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.createDate', '创建日期'),
        field: "createDate",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.createUser', '创建人'),
        field: "createUser",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.seq', '序号'),
        field: "seq",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.saveDb', '是否保存数据库'),
        field: "saveDb",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.dataContent', '文件内容'),
        field: "dataContent",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.status', '状态'),
        field: "status",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.extension', '拓展名'),
        field: "extension",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciFileInfo.fileLength', '文件大小'),
        field: "fileLength",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
];
