import {tm} from '@i18nHelper'

export const searchFormSchema = [
    {

        label: tm('eciNsBizType.code', 'code'),
        field: "code",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsBizType.name', 'name'),
        field: "name",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsBizType.status', 'status'),
        field: "status",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "Y|是,N|否"
        },
    },
    {

        label: tm('eciNsBizType.assemblyName', 'assemblyName'),
        field: "assemblyName",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
];

export const columns = [
    {
        label: tm('eciNsBizType.code', 'code'),
        field: "code",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.name', 'name'),
        field: "name",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.status', 'status'),
        field: "statusName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.seq', 'seq'),
        field: "seq",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.memo', 'memo'),
        field: "memo",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.createDate', 'createDate'),
        field: "createDate",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.createUser', 'createUser'),
        field: "createUser",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.updateDate', 'updateDate'),
        field: "updateDate",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.updateUser', 'updateUser'),
        field: "updateUser",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.assemblyName', 'assemblyName'),
        field: "assemblyName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.viewUrl', 'viewUrl'),
        field: "viewUrl",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.action1Name', 'action1Name'),
        field: "action1Name",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.action2Name', 'action2Name'),
        field: "action2Name",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.action3Name', 'action3Name'),
        field: "action3Name",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.subUrl', 'subUrl'),
        field: "subUrl",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.catelog', 'catelog'),
        field: "catelog",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.printUrl', 'printUrl'),
        field: "printUrl",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.applyCatelog', 'applyCatelog'),
        field: "applyCatelog",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsBizType.bizId', 'bizId'),
        field: "bizId",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
];
