import {tm} from '@i18nHelper'

export const searchFormSchema = [
    {
        label: tm('eciNsTask.taskId', '审单编号'),
        field: "taskId",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "T1.TASK_ID|s|=|and",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {
        label: tm('eciNsTask.bizNo', '单证编号'),
        field: "bizNo",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "T1.BIZ_NO|s|=|and",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsTask.customerNo', '企业内控编号'),
        field: "customerNo",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "T1.CUSTOMER_NO|s|=|and",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },

    {

        label: tm('eciNsTask.status', '内审状态'),
        field: "status",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "T1.STATUS|s|=|and",
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "TJNS|提交内审,PASS1|一级审批通过,PASS2|二级审批通过,PASS3|三级审批通过,NSOK|内审通过,BACK1|一级审批退回,BACK2|二级审批退回,BACK3|三级审批退回,NSBACK|内审退回,SBOK|已申报,SBZF|已作废申报"
        },
    },
    {

        label: tm('eciNsTask.applyUser', '申请人'),
        field: "applyUser",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "T1.APPLY_USER|s|=|and",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsTask.applyDate', '申请日期'),
        field: "applyDate",
        labelWidth: "160px",
        span: 12,
        show: true,
        query: "T1.APPLY_DATE|d|between|and",
        component: "DateRange", //控件类型：Input,Select,Choose,DateRange,DateTimeRange
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsTask.bizType', '内审类型'),
        field: "bizType",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "T1.BIZ_TYPE|s|=|and",
        component: "Select",
        componentProps: {
            dataType: "TG_NS_BIZ_TYPE",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsTask.inputUser', '录入人'),
        field: "inputUser",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "T1.INPUT_USER|s|=|and",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsTask.inputDate', '录入日期'),
        field: "inputDate",
        labelWidth: "160px",
        span: 12,
        show: true,
        query: "T1.INPUT_DATE|d|between|and",
        component: "DateRange", //控件类型：Input,Select,Choose,DateRange,DateTimeRange
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsTask.auditFlag', '已审批'),
        field: "auditFlag",
        labelWidth: "160px",
        span: 6,
        show: true,
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "Y|是"
        },
    },

];

export const columns = [
    {
        label: tm('eciNsTask.taskId', '审单编号'),
        field: "taskId",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.bizNo', '业务编号'),
        field: "bizNo",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.customerNo', '企业内控编号'),
        field: "customerNo",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.bizType', '内审类型'),
        field: "bizTypeName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.applyDate', '申请日期'),
        field: "applyDate",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.applyUser', '申请人'),
        field: "applyUser",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.status', '内审状态'),
        field: "statusName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.tradeName', '经营单位'),
        field: "tradeName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.companyName', '操作企业'),
        field: "companyName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.dclName', '申报企业'),
        field: "dclName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.qwName', '区外企业'),
        field: "qwName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },


    {
        label: tm('eciNsTask.createDate', '创建日期'),
        field: "createDate",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTask.createUser', '创建人'),
        field: "createUser",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
];
