import {tm} from '@i18nHelper'

export const searchFormSchema = [
    {

        label: tm('eciNsTrace.taskId', '审单编号'),
        field: "taskId",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",

        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
            disabled: true,
        },
    },
    {

        label: tm('eciNsTrace.bizNo', '业务编号'),
        field: "bizNo",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsTrace.bizType', '内审类型'),
        field: "bizType",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "TJNS|提交内审,PASS1|一级审批通过,PASS2|二级审批通过,PASS3|三级审批通过,NSOK|内审通过,BACK1|一级审批退回,BACK2|二级审批退回,BACK3|三级审批退回,NSBACK|内审退回,SBOK|已申报,SBZF|已作废申报"

        },
    },
    {

        label: tm('eciNsTrace.operUser', '操作人'),
        field: "operUser",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsTrace.operDate', '操作日期'),
        field: "operDate",
        labelWidth: "160px",
        span: 12,
        show: true,
        query: "auto",
        component: "DateRange",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
];

export const columns = [
    {
        label: tm('eciNsTrace.taskId', '审单编号'),
        field: "taskId",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTrace.bizNo', '业务编号'),
        field: "bizNo",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTrace.bizType', '内审类型'),
        field: "bizType",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTrace.operUser', '操作人'),
        field: "operUser",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTrace.operDate', '操作日期'),
        field: "operDate",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTrace.auditMemo', '审批意见'),
        field: "auditMemo",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('eciNsTrace.operName', '操作名称'),
        field: "operName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
];
