import {tm} from '@i18nHelper'

export const searchFormSchema = [
    {

        label: tm('sysOperLog.title', '操作模块'),
        field: "title",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('sysOperLog.requestMethod', '请求方式'),
        field: "requestMethod",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('eciNsBizType.businessType', '业务类型'),
        field: "businessType",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "0|其它,1|新增,2|修改,3|删除"
        },
    },
    {

        label: tm('sysOperLog.operTime', '操作时间'),
        field: "operTime",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "DateRange",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
];

export const columns = [
    {
        label: tm('sysOperLog.operTime', '操作时间'),
        field: "operTime",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.title', '操作模块'),
        field: "title",
        show: true,
        width: "260px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.businessType', '业务类型'),
        field: "businessType",
        show: true,
        width: "100px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.operStatus', '操作状态'),
        field: "operStatus",
        show: true,
        width: "100px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.errorMsg', '错误消息'),
        field: "errorMsg",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.operUrl', '请求url'),
        field: "operUrl",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.method', '请求后端方法'),
        field: "method",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.requestMethod', '请求方式'),
        field: "requestMethod",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.operParam', '请求参数'),
        field: "operParam",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },

    {
        label: tm('sysOperLog.operIp', '操作地址'),
        field: "operIp",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.operLocation', '操作地点'),
        field: "operLocation",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },


    {
        label: tm('sysOperLog.jsonResult', '返回响应体'),
        field: "jsonResult",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.userId', '用户id'),
        field: "userId",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.operOs', '操作系统'),
        field: "operOs",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.browser', '浏览器'),
        field: "browser",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.server', '本地服务器'),
        field: "server",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('sysOperLog.loginName', '用户登录名'),
        field: "loginName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
];
