
import { tmn, tm, t } from "@i18nHelper";

export const searchFormSchema = [
  {
    label: t("tg.page.main.taskCenter.taskName"), //显示中文名 任务名称
    field: "taskName", //字段名称
    columnCode: "taskName", //字段名称 兼容老的
    span: 8, //控件占位长度
    labelWidth: "150px", //label占用长度
    show: true, //是否显示该控件
    query: "auto", //查询配置
    component: "Input", //控件类型：Input,Select,Choose,DateRange,DateTimeRange
    componentProps: {},
  },
  {
    label: t("tg.page.main.taskCenter.taskType"), //显示中文名 任务类型
    field: "taskType", //字段名称
    columnCode: "taskType", //字段名称
    span: 8, //控件占位长度
    labelWidth: "150px", //label占用长度
    show: true, //是否显示该控件
    query: "auto", //查询配置
    component: "Input", //控件类型：Input,Select,Choose,DateRange,DateTimeRange
    componentProps: {},
  },
  {
    label: t("tg.page.main.taskCenter.taskStatus"), //显示中文名 执行状态
    field: "taskStatus", //字段名称
    columnCode: "taskStatus", //字段名称
    span: 8, //控件占位长度
    labelWidth: "150px", //label占用长度
    show: true, //是否显示该控件
    query: "auto", //查询配置
    component: "Select", //控件类型：Input,Select,Choose,DateRange,DateTimeRange
    componentProps: {
      //组件属性对象
      //dataType: "", //放大镜，下拉框的数据来源
      placeholder: t("tg.page.common.chooseHint"), //背景提示文本 请选择
      addEmpty: true,
      dataCustom: t("tg.page.main.taskCenter.M00163").replaceAll("-", "|")//"0-进行中,1-已完成,2-异常结束"
    },
  },
];

export const columns = [
  {
    label: "id",
    field: "id",
    show: false,
    width: "160px",
    export: false,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.taskName"), //任务名称
    field: "taskName",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.taskDoc"),//任务编号
    field: "taskNo",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.taskType"),//任务类型
    field: "taskType",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.relLink"),//相关链接
    field: "linkUrl",
    show: true,
    width: "260px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.taskStatus"),//任务状态
    field: "taskStatus",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.taskProcess"),//任务进度
    field: "taskProcess",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.taskProcessDesc"),//当前任务描述
    field: "taskProcessDesc",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.createUser"),//创建用户ID
    field: "createUser",
    show: false,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  // {
  //   label: t("tg.page.main.taskCenter.createTime"),//创建时间
  //   field: "createTime",
  //   show: true,
  //   width: "160px",
  //   export: true,
  //   fixed: false,
  //   columnProps: {
  //     "show-overflow-tooltip": true,
  //     sortable: false,
  //   },
  // },
  {
    label: t("tg.page.main.taskCenter.execStartTime"),//执行开始时间
    field: "createTime",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.execEndTime"),//执行结束时间
    field: "updateTime",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
  {
    label: t("tg.page.main.taskCenter.remark"),//备注信息
    field: "remark",
    show: true,
    width: "160px",
    export: true,
    fixed: false,
    columnProps: {
      "show-overflow-tooltip": true,
      sortable: false,
    },
  },
];
