import {tm} from '@i18nHelper'

export const searchFormSchema = [
    {

        label: tm('tgJob.name', '任务名称'),
        field: "name",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('tgJob.status', '任务状态'),
        field: "status",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "1|正常,2|暂停,0|初始化中",
        },
    },
    {

        label: tm('tgJob.handlerName', '处理器的名字'),
        field: "handlerName",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
];

export const columns = [
    {
        label: tm('tgJob.id', '任务编号'),
        field: "id",
        show: true,
        width: "60px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJob.name', '任务名称'),
        field: "name",
        show: true,
        width: "180px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJob.status', '任务状态'),
        field: "statusName",
        show: true,
        width: "60px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJob.handlerName', '处理器的名字'),
        field: "handlerName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJob.handlerParam', '处理器的参数'),
        field: "handlerParam",
        show: true,
        width: "200px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJob.cronExpression', 'CRON 表达式'),
        field: "cronExpression",
        show: true,
        width: "200px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
];
