import {tm} from '@i18nHelper'

export const searchFormSchema = [

    {

        label: tm('tgJobLog.handlerName', '处理器的名字'),
        field: "handlerName",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('tgJobLog.beginTime', '开始执行时间'),
        field: "beginTime",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "DateRange",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('tgJobLog.endTime', '结束执行时间'),
        field: "endTime",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "DateRange",
        componentProps: {
            dataType: "",
            placeholder: "",
        },
    },
    {

        label: tm('tgJobLog.status', '任务状态'),
        field: "status",
        labelWidth: "160px",
        span: 6,
        show: true,
        query: "auto",
        component: "Select",
        componentProps: {
            dataType: "",
            placeholder: "",
            dataCustom: "1|成功,2|失败,0|运行中",
        },
    },
    {

        label: tm('tgJobLog.jobId', '任务编号'),
        field: "jobId",
        labelWidth: "160px",
        span: 6,
        show: false,
        query: "A.JOB_ID|s|=|and",
        component: "Input",
        componentProps: {
            dataType: "",
            placeholder: "",
            disabled: true,
            visible: false,
        },
    },
];

export const columns = [
    {
        label: tm('tgJobLog.id', '日志编号'),
        field: "id",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJobLog.jobId', '任务编号'),
        field: "jobId",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJobLog.handlerName', '处理器的名字'),
        field: "handlerName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJobLog.handlerParam', '处理器的参数'),
        field: "handlerParam",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJobLog.executeIndex', '第几次执行'),
        field: "executeIndex",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJobLog.beginTime', '开始执行时间'),
        field: "beginTime",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJobLog.endTime', '结束执行时间'),
        field: "endTime",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJobLog.duration', '执行时长'),
        field: "duration",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
    {
        label: tm('tgJobLog.status', '任务状态'),
        field: "statusName",
        show: true,
        width: "160px",
        export: true,
        fixed: false,
        columnProps: {
            "show-overflow-tooltip": true,
            sortable: false,
        },
    },
];
