import service from '@core/utils/TgImport/request'
const BaseUrl = (window.global && window.global.baseUrl) || (import.meta.env.VITE_API_URL as any)
export const getDataSourceApi = (status: Number) => {
	return service.post('/tgExcelDatasource/selectList', {
		status: status
	})
}
export const getTablesApi = (id: string) => {
	let formData = new FormData()
	// @ts-ignore
	formData.append('datasourceId', id)
	return service.post('/tgExcelDatasource/getTables', formData)
}

export const getTableColumnsApi = async (id: string, tableCode: string) => {
	let formData = new FormData()
	formData.append('datasourceId', id)
	formData.append('tableCode', tableCode)
	return service.post('/tgExcelDatasource/getTableColumns', formData)
}

export const getDataSourceItemData = async (id: string) => {
	return service.post('/tgExcelDatasource/selectOne', { id: id })
}

export const insertNewDataTemplate = async (data: any) => {
	return service.post('/tgExcelTemplate/insertTemplate', data)
}

export const copyTemplateApi = async (id: string) => {
	let formData = new FormData()
	formData.append('id', id)
	return service.post('/tgExcelTemplate/copy', formData)
}

export const editTemplateApi = (id: string) => {
	return service.post('/tgExcelTemplate/selectOneById', { id: id })
}

export const updateDataTemplate = async (data: any) => {
	return service.post('/tgExcelTemplate/updateTemplate', data)
}

export const getTestColumnsApi = async (data: any) => {
	let formData = new FormData()
	formData.append('excelData', data)
	return service.post('/tgExcelTemplate/saveTemplateTest', formData)
}

export const getTransformApi = async (data: any) => {
	let formData = new FormData()
	formData.append('file', data.raw)
	return service.post('/tgExcelTemplate/transform', formData)
}

export const getTestTransformApi = async (data: any) => {
	let formData = new FormData()
	formData.append('file', data.raw)
	return service.post('/sjmfExcelTemplate/excelChange', formData)
}

export const uploadImageApi = async (data: any) => {
	let formData = new FormData()
	formData.append('file', data.raw)
	return service.post('/tgExcelTemplate/uploadImage', formData)
}

export const downloadByIdsApi = async (data: any) => {
	// location.href = import.meta.env.VITE_API_URL + '/tgExcelTemplate/downloadByIds?templateIds=' + data.join(',')
	// location.href = BaseUrl + '/tgExcelTemplate/downloadByIds?templateIds=' + data.join(',')
	location.href = BaseUrl + '/tgExcelTemplate/generateAndDownloadExcels?templateIds=' + data.join(',')
}

export const outPutTemplateApi = async (data: string) => {
	// location.href = import.meta.env.VITE_API_URL + '/tgExcelTemplate/settingOutput?templateId=' + data
	location.href = BaseUrl + '/tgExcelTemplate/settingOutput?templateId=' + data
}
export const outPutTemplatesApi = async (data: string) => {
	// location.href = import.meta.env.VITE_API_URL + '/tgExcelTemplate/settingOutput?templateIds=' + data
	location.href = BaseUrl + '/tgExcelTemplate/settingOutput?templateIds=' + data
}
export const importTemplateApi = async (data: any) => {
	let formData = new FormData()
	formData.append('file', data.raw)
	return service.post('/tgExcelTemplate/settingInput', formData)
}
